Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.wrapper
Class VirtualCopy.VirtualCopier

    java.lang.Object
      net.sf.saxon.tree.wrapper.VirtualCopy.VirtualCopier

All Implemented Interfaces:
  SequenceIterator, AxisIterator, UnfailingIterator

Direct Known Subclasses:
  VirtualUntypedCopy.VirtualUntypedCopier

Enclosing class:
  VirtualCopy

    protected class VirtualCopy.VirtualCopier

extends Object
implements AxisIterator

VirtualCopier implements the XPath axes as applied to a VirtualCopy node. It works by applying the requested axis to the node of which this is a copy. There are two complications: firstly, all nodes encountered must themselves be (virtually) copied to give them a new identity. Secondly, axes that stray outside the subtree rooted at the original copied node must be truncated.

Field Summary
`protected AxisIterator` | `base`
`protected NodeInfo` | `subtreeRoot`

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`VirtualCopy.VirtualCopier(AxisIterator base, VirtualCopy parent, NodeInfo subtreeRoot)`

Method Summary
`Value` | `atomize()` Return the atomized value of the current node.
`void` | `close()` Close the iterator.
`protected VirtualCopy` | `createCopy(NodeInfo node, NodeInfo root)` Method to create the virtual copy of a node encountered when navigating.
`NodeInfo` | `current()` Get the current item in the sequence.
`AxisIterator` | `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`CharSequence` | `getStringValue()` Return the string value of the current node.
`AxisIterator` | `iterateAxis(byte axis, NodeTest test)` Return an iterator over an axis, starting at the current node.
`boolean` | `moveNext()` Move to the next node, without returning it.
`NodeInfo` | `next()` Get the next item in the sequence.
`int` | `position()` Get the current position

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### base

    protected AxisIterator base

### subtreeRoot

    protected NodeInfo subtreeRoot

Constructor Detail

### VirtualCopy.VirtualCopier

    public VirtualCopy.VirtualCopier(AxisIterator base,
                                     VirtualCopy parent,
                                     NodeInfo subtreeRoot)

Method Detail

### moveNext

    public boolean moveNext()

  Move to the next node, without returning it. Returns true if there is a next node, false if the end of the sequence has been reached. After calling this method, the current node may be retrieved using the current() function.

  Specified by:
    `moveNext` in interface `AxisIterator`
  Returns:
    true if there is a next node, false if the end of the sequence has been reached

### next

    public NodeInfo next()

  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator`
  Specified by:
    `next` in interface `AxisIterator`
  Specified by:
    `next` in interface `UnfailingIterator`
  Returns:
    the next Item. If there are no more nodes, return null.

### current

    public NodeInfo current()

  Get the current item in the sequence.

  Specified by:
    `current` in interface `SequenceIterator`
  Specified by:
    `current` in interface `AxisIterator`
  Specified by:
    `current` in interface `UnfailingIterator`
  Returns:
    the current item, that is, the item most recently returned by next()

### position

    public int position()

  Get the current position

  Specified by:
    `position` in interface `SequenceIterator`
  Specified by:
    `position` in interface `UnfailingIterator`
  Returns:
    the position of the current item (the item most recently returned by next()), starting at 1 for the first node

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator`

### iterateAxis

    public AxisIterator iterateAxis(byte axis,
                                    NodeTest test)

  Return an iterator over an axis, starting at the current node.

  Specified by:
    `iterateAxis` in interface `AxisIterator`
  Parameters:
    `axis` - the axis to iterate over, using a constant such as `Axis.CHILD`
    `test` - a predicate to apply to the nodes before returning them.
  Returns:
    an iterator over an axis, starting at the current node
  Throws:
    `NullPointerException` - if there is no current node

### atomize

    public Value atomize()
                  throws XPathException

  Return the atomized value of the current node.

  Specified by:
    `atomize` in interface `AxisIterator`
  Returns:
    the atomized value.
  Throws:
    `NullPointerException` - if there is no current node
    `XPathException` - if the current node cannot be atomized, for example because it is an element node with element-only content.

### getStringValue

    public CharSequence getStringValue()

  Return the string value of the current node.

  Specified by:
    `getStringValue` in interface `AxisIterator`
  Returns:
    the string value, as an instance of CharSequence.
  Throws:
    `NullPointerException` - if there is no current node

### getAnother

    public AxisIterator getAnother()

  Get another iterator over the same sequence of items, positioned at the start of the sequence

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Specified by:
    `getAnother` in interface `AxisIterator`
  Specified by:
    `getAnother` in interface `UnfailingIterator`
  Returns:
    a new iterator over the same sequence

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

### createCopy

    protected VirtualCopy createCopy(NodeInfo node,
                                     NodeInfo root)

  Method to create the virtual copy of a node encountered when navigating. This method is separated out so that it can be overridden in a subclass.

  Parameters:
    `node` - the node to be copied
    `root` - the root of the tree
  Returns:
    the virtual copy

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.